/*
	relay2cl.h
	Library for controlling 2 coil latching relays.
	Pietro Maoddi // 21.02.2017 // pietro.maoddi@gmail.com
*/

#ifndef relay2cl_h
#define relay2cl_h

// DEBUG ---------------------------------------------------------------------

// INCLUDES ------------------------------------------------------------------

// MACROS --------------------------------------------------------------------

// DEFINES -------------------------------------------------------------------

// CLASSES -------------------------------------------------------------------

class TwoCoilRelay
{
	public:
		TwoCoilRelay(uint8_t pin1, uint8_t pin2, uint16_t hold_time = 10, bool activeLow = false);
		void Select(uint8_t input);
		
	private:
		uint8_t pin1, pin2;
		uint8_t ACTIVE, INACTIVE;
		uint16_t holdTime;
};

#endif
