# -*- coding: utf-8 -*-
"""
Created on Tue Jan 08 16:59:42 2019

@author: adminclse
"""

from PyQt4 import QtGui,uic, QtCore
from PyQt4.QtCore import QThread, SIGNAL
import sys
import time
import os
import numpy as np
import Arduino
import gc
from datetime import datetime

class getPostsThread(QThread):
    def __init__(self, window):
        QThread.__init__(self)
        self.window = window
        self.window.exitFlag = 0
        self.i = 0   
        self.experiment_time = time.strftime("%Y%m%d_%H.%M")
        self.ResultsA = []
        self.ResultsB = []
        self.Resultstime = []
        self.Resultsfreq = []
        self.end = 0
        
        
    def measuring(self):
        
            if self.window.exitFlag == 0:
                for i in range(1,20):
                    checkbox1 = self.window.findChild(QtGui.QRadioButton, "radioButton_r%02db" %i)
                    if checkbox1.isChecked() == True and self.window.exitFlag == 0:
                        try:
                            self.window.arduino.set_only("r%02db" %i)
                            self.window.Log_text.append('Connected trap r' + str(i))
#                            self.window.trapname1_label.setText("Trap Right %02da"%(i))
                        except BaseException, e:
                            self.window.Log_text.append('%s Failed measurement: \n' + str(e))
                            self.window.exitFlag == 1
                            break
                    checkbox2 = self.window.findChild(QtGui.QRadioButton, "radioButton_l%02db" %i) # check for button on the left side b
                    if checkbox2.isChecked() == True and self.window.exitFlag == 0:
                        try:
                            self.window.arduino.set_only("l%02db" %i)
                            self.window.Log_text.append('Connected trap l' + str(i))
#                            self.window.trapname1_label.setText("Trap Left %02db"%(i))
                        except BaseException, e:
                            self.window.Log_text.append('%s Failed measurement: \n' + str(e))
                            self.window.exitFlag == 1
                            break
#            except BaseException, e:
#                self.window.Log_text.append('%s Failed measurement with the Impedance Analyzer: \n'+ str(e)) 
#                self.emit(SIGNAL('terminated'))
#                break
            self.termination()
            
               
                
            
    def termination(self):
        try:         
            if self.window.exitFlag == 1:
                        self.window.Log_text.append("%s Measurement completed"%(time.strftime("%H:%M:%S")))
                        self.emit(SIGNAL('terminated'))
        except BaseException, e:
            self.window.Log_text.append('%s Failed measurement, check the Measurement Settings: \n'%time.strftime("%H:%M:%S") + str(e)) 
            self.emit(SIGNAL('terminated'))
            
    def run(self): # Set the measurement in a repetitive way
        self.measuring()
#        self.emit(SIGNAL('add_line')) 
#        self.window.arduino.close_serial()
#        self.emit(SIGNAL('terminated'))