# -*- coding: utf-8 -*-
"""
Created on Tue Jan 08 16:11:10 2019

@author: adminclse
"""

from PyQt4 import QtGui,uic, QtCore
from PyQt4.QtCore import QThread, SIGNAL
import time


import sys
import Arduino
import Measure_Thread2
import Initialization_Thread2
import zhinst.ziPython, zhinst.utils
import os
import visa
import numpy as np
import gc


form_class = uic.loadUiType("Form2.ui")[0] # Load the UI

class MyWindowClass(QtGui.QMainWindow, form_class):
    def __init__(self):
        super(self.__class__, self).__init__()
        self.setupUi(self)
        self.experiment_number = 1
        self.Instrumentselected = 0
        
        self.Initialize_btn.clicked.connect(self.Initialize)
        
        self.radioButton_l01b.toggled.connect(lambda:self.radioButtons(self.radioButton_l01b)) # connect the btn with the button created in the graphic inteface
        self.radioButton_l02b.toggled.connect(lambda:self.radioButtons(self.radioButton_l02b))
        self.radioButton_l03b.toggled.connect(lambda:self.radioButtons(self.radioButton_l03b))
        self.radioButton_l04b.toggled.connect(lambda:self.radioButtons(self.radioButton_l04b))
        self.radioButton_l05b.toggled.connect(lambda:self.radioButtons(self.radioButton_l05b))
        self.radioButton_l06b.toggled.connect(lambda:self.radioButtons(self.radioButton_l06b))
        self.radioButton_l07b.toggled.connect(lambda:self.radioButtons(self.radioButton_l07b))
        self.radioButton_l08b.toggled.connect(lambda:self.radioButtons(self.radioButton_l08b))
        self.radioButton_l09b.toggled.connect(lambda:self.radioButtons(self.radioButton_l09b))
        self.radioButton_l10b.toggled.connect(lambda:self.radioButtons(self.radioButton_l10b))
        self.radioButton_l11b.toggled.connect(lambda:self.radioButtons(self.radioButton_l11b))
        self.radioButton_l12b.toggled.connect(lambda:self.radioButtons(self.radioButton_l12b))
        self.radioButton_l13b.toggled.connect(lambda:self.radioButtons(self.radioButton_l13b))
        self.radioButton_l14b.toggled.connect(lambda:self.radioButtons(self.radioButton_l14b))
        self.radioButton_l15b.toggled.connect(lambda:self.radioButtons(self.radioButton_l15b))
        self.radioButton_l16b.toggled.connect(lambda:self.radioButtons(self.radioButton_l16b))
        self.radioButton_l17b.toggled.connect(lambda:self.radioButtons(self.radioButton_l17b))
        self.radioButton_l18b.toggled.connect(lambda:self.radioButtons(self.radioButton_l18b))
        self.radioButton_l19b.toggled.connect(lambda:self.radioButtons(self.radioButton_l19b))
##        self.radioButton_l20b.toggled.connect(lambda:self.radioButtons(self.radioButton_l20b))
        
        self.radioButton_r01b.toggled.connect(lambda:self.radioButtons(self.radioButton_r01b))
        self.radioButton_r02b.toggled.connect(lambda:self.radioButtons(self.radioButton_r02b))
        self.radioButton_r03b.toggled.connect(lambda:self.radioButtons(self.radioButton_r03b))
        self.radioButton_r04b.toggled.connect(lambda:self.radioButtons(self.radioButton_r04b))
        self.radioButton_r05b.toggled.connect(lambda:self.radioButtons(self.radioButton_r05b))
        self.radioButton_r06b.toggled.connect(lambda:self.radioButtons(self.radioButton_r06b))
        self.radioButton_r07b.toggled.connect(lambda:self.radioButtons(self.radioButton_r07b))
        self.radioButton_r08b.toggled.connect(lambda:self.radioButtons(self.radioButton_r08b))
        self.radioButton_r09b.toggled.connect(lambda:self.radioButtons(self.radioButton_r09b))
        self.radioButton_r10b.toggled.connect(lambda:self.radioButtons(self.radioButton_r10b))
        self.radioButton_r11b.toggled.connect(lambda:self.radioButtons(self.radioButton_r11b))
        self.radioButton_r12b.toggled.connect(lambda:self.radioButtons(self.radioButton_r12b))
        self.radioButton_r13b.toggled.connect(lambda:self.radioButtons(self.radioButton_r13b))
        self.radioButton_r14b.toggled.connect(lambda:self.radioButtons(self.radioButton_r14b))
        self.radioButton_r15b.toggled.connect(lambda:self.radioButtons(self.radioButton_r15b))
        self.radioButton_r16b.toggled.connect(lambda:self.radioButtons(self.radioButton_r16b))
        self.radioButton_r17b.toggled.connect(lambda:self.radioButtons(self.radioButton_r17b))
        self.radioButton_r18b.toggled.connect(lambda:self.radioButtons(self.radioButton_r18b))
        self.radioButton_r19b.toggled.connect(lambda:self.radioButtons(self.radioButton_r19b))
        
        self.measure_btn.clicked.connect(self.start_getting_measure)
        self.measurement_type = 1
        self.exitFlag = 0
#        self.set_settings_btn.setEnabled(False)
        self.Initialize_btn.setEnabled(True)
        self.measure_btn.setEnabled(False)
        
        
    """Instrument inizialization"""
    def Initialize(self):
        self.initialize_thread = Initialization_Thread2.initialization_thread(self)
        self.connect(self.initialize_thread, SIGNAL("terminated"), self.end_initialization)
        self.initialize_thread.start()
#        self.set_settings_btn.setEnabled(False)
        self.Initialize_btn.setEnabled(False)
#        self.measure_btn.setEnabled(False)
        self.measure_btn.setEnabled(True)
        
    """ Define a radiobutton"""    
    def radioButtons(self,b):
        if b.isChecked() == True:
            b.setChecked(True)
        elif b.isChecked == False:
            b.setChecked(False) 
            
    """ Define the end of the initialization"""        
    def end_initialization(self):
        self.initialize_thread.terminate
#        self.set_settings_btn.setEnabled(True)
        self.Initialize_btn.setEnabled(True)

    """Measurement thread"""
    def start_getting_measure(self):
        try: 
            self.t0 = time.clock()
            self.status_measurement = 1
            self.exitFlag = 0
            self.get_thread = Measure_Thread2.getPostsThread(self)
#            self.connect(self.get_thread, SIGNAL("add_line"), self.add_line) 
#            self.connect(self.get_thread, SIGNAL("terminated"), self.done)
            self.get_thread.start()

            self.measure_btn.setEnabled(True) # set the button to off
            self.Initialize_btn.setEnabled(True)

            self.COMarduino.setEnabled(True)
            
#            for i in range(1,20):# Disable all the buttons
#                checkbox = self.findChild(QtGui.QRadioButton, "radioButton_l%02db" %i)
#                checkbox.setEnabled(False)
#            for i in range(1,20):# Disable all the buttons
#                checkbox = self.findChild(QtGui.QRadioButton, "radioButton_r%02db" %i)
#                checkbox.setEnabled(False)
        except BaseException, e:
            self.Log_text.append('%s Problem starting the new thread: \n'%time.strftime("%H:%M:%S") + str(e))
            self.exitFlag = 1
            self.get_thread.terminate  
            
def main():
    app = QtGui.QApplication(sys.argv)
    form = MyWindowClass()
    form.show()
    app.exec_()

if __name__ == '__main__':
    main()            
        